﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AlgorithmByCSharp.FindNthFromEnd
{
    class NthNode
    {
        public int data;
        public NthNode next;
        public NthNode(int data)
        {
            this.data = data;
        }
    }
    
    class NthFromEnd
    {
        public NthNode FindNth(NthNode head, int n)
        {
            NthNode p1 = head;
            NthNode p2 = head;
            //把p2指针移动到正数第n个结点
            for (int i = 1; i < n; i++)
            {
                p2 = p2.next;
                if (p2 == null)
                {
                    Console.WriteLine("参数n超出链表长度！");
                }
            }
            //p1和p2一起右移，直到p2指向链表尾结点
            while (p2.next != null)
            {
                p1 = p1.next;
                p2 = p2.next;
            }
            return p1;
        }
        //快速创建链表
        public NthNode BuildLinkList(int[] array)
        {
            NthNode head = new NthNode(array[0]);
            NthNode p = head;
            for (int i = 0; i < array.Length; i++)
            {
                p.next = new NthNode(array[i]);
                p = p.next;
            }
            return head;
        }
    }
}